﻿Imports System.Linq
Imports System.Data
Imports System.Configuration
Imports System.Data.SqlClient

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Me.BindGrid()
        End If
    End Sub

    Private Sub BindGrid()
        Dim query As String = "SELECT TOP 30 OrderID,"
        query += "(SELECT ProductName FROM Products WHERE ProductID = details.ProductId) ProductName,"
        query += "(Quantity * UnitPrice) Price"
        query += " FROM [Order Details] details"
        query += " ORDER BY OrderID"
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand(query)
                Using sda As New SqlDataAdapter()
                    cmd.Connection = con
                    sda.SelectCommand = cmd
                    Using dt As New DataTable()
                        sda.Fill(dt)
                        GridView1.DataSource = dt
                        GridView1.DataBind()

                        'Calculate Sum and display in Footer Row
                        Dim total As Decimal = dt.AsEnumerable().Sum(Function(row) row.Field(Of Decimal)("Price"))
                        GridView1.FooterRow.Cells(1).Text = "Total"
                        GridView1.FooterRow.Cells(1).HorizontalAlign = HorizontalAlign.Right
                        GridView1.FooterRow.Cells(2).Text = total.ToString("N2")
                    End Using
                End Using
            End Using
        End Using
    End Sub

    Protected Sub OnPageIndexChanging(sender As Object, e As GridViewPageEventArgs)
        GridView1.PageIndex = e.NewPageIndex
        Me.BindGrid()
    End Sub
End Class